<?php
/*
JP_LinksEdit Version Alpha 1
See the file license.txt distributed with this file for license details.

This file's versioning is separate from jp-links.

This file will do at least most admin tasks for you, It has not been well
 tests and you may encounter problems. This is an alpha release. Feel free
 to make improvements and send them to me only if you think they would be
 worth my seeing and possibly including.

The source is messy and at least a little buggy. Be prepared. I have tried
 to stick to WP coding conventions/styles as much as possible, within reason.
 The main aim of this is to get a reasonably working admin interface, it is not
 intended to be feature rich, intuitive, or have a high degree of error
 handling. This means it has been produced to perform the essential tasks and
 with limited consideration for how it does this. This said it should work
 alright for you on a standard install. I have used it with WP 1.2.2.

I plan on improving this script in the near future.

The script allows you to view, add, edit, and delete links. It also has install
 and uninstall functions.

*/
require_once('../wp-includes/wp-l10n.php');

$title = __('JP-Links Manager');
require_once('admin-header.php');

if (!get_magic_quotes_gpc()) {
$_POST   = add_magic_quotes($_POST);
}

(isset($_GET['action'])) ? $action = $_GET['action'] : $action = 'view';

$tablejplinks		= $table_prefix . 'jp_links';
$tablejplink2cat	= $table_prefix . 'jp_link2cat';

// - Functions -------------------------------------------------------------------------------

function add_magic_quotes($array) { // WP's add_magic_quotes as found in WP 1.2.2 - post.php
	foreach ($array as $k => $v) {
		if (is_array($v)) {
			$array[$k] = add_magic_quotes($v);
		} else {
			$array[$k] = addslashes($v);
		}
	}
	return $array;
}

function jpa_get_the_category() { // Edited version of WP's get_the_category as found in WP 1.2.2 - template-functions-category.php
    global $link, $tablecategories, $tablejplink2cat, $wpdb, $category_cache;
//    if ($category_cache[$post->ID]) {
//        return $category_cache[$post->ID];
//    } else {
        $categories = $wpdb->get_results("
            SELECT category_id, cat_name, category_nicename, category_description, category_parent
            FROM  $tablecategories, $tablejplink2cat
            WHERE $tablejplink2cat.category_id = cat_ID AND $tablejplink2cat.jplink_id = $link->jplink_id
            ");
    
        return $categories;
//    }
}

function jpa_the_category($seperator = '', $parents='') { // Edited version of WP's the_category as found in WP 1.2.2 - May have redundant stuff, havent really looked at it. - template-functions-category.php
    $categories = jpa_get_the_category();
    $thelist = '';
    if ('' == $seperator) {
        $thelist .= '<ul class="post-categories">';
        foreach ($categories as $category) {
            $category->cat_name = stripslashes($category->cat_name);
            $thelist .= "\n\t<li>";
            switch(strtolower($parents)) {
                case 'multiple':
                    if ($category->category_parent) {
                        $thelist .= get_category_parents($category->category_parent, TRUE);
                    }
                    $thelist .= '<a href="' . get_category_link(0, $category->category_id, $category->category_nicename) . '" title="' . sprintf(__("View all posts in %s"), $category->cat_name) . '">'.$category->cat_name.'</a></li>';
                    break;
                case 'single':
                    $thelist .= '<a href="' . get_category_link(0, $category->category_id, $category->category_nicename) . '" title="' . sprintf(__("View all posts in %s"), $category->cat_name) . '>';
                    if ($category->category_parent) {
                        $thelist .= get_category_parents($category->category_parent, FALSE);
                    }
                    $thelist .= $category->cat_name.'</a></li>';
                    break;
                case '':
                default:
                    $thelist .= '<a href="' . get_category_link(0, $category->category_id, $category->category_nicename) . '" title="' . sprintf(__("View all posts in %s"), $category->cat_name) . '">'.$category->cat_name.'</a></li>';
            }
        }
        $thelist .= '</ul>';
    } else {
        $i = 0;
        foreach ($categories as $category) {
            $category->cat_name = stripslashes($category->cat_name);
            if (0 < $i) $thelist .= $seperator . ' ';
            switch(strtolower($parents)) {
                case 'multiple':
                    if ($category->category_parent)    $thelist .= get_category_parents($category->category_parent, TRUE);
                    $thelist .= '<a href="' . get_category_link(0, $category->category_id, $category->category_nicename) . '" title="' . sprintf(__("View all posts in %s"), $category->cat_name) . '">'.$category->cat_name.'</a>';
                case 'single':
                    $thelist .= '<a href="' . get_category_link(0, $category->category_id, $category->category_nicename) . '" title="' . sprintf(__("View all posts in %s"), $category->cat_name) . '">';
                    if ($category->category_parent)    $thelist .= get_category_parents($category->category_parent, FALSE);
                    $thelist .= "$category->cat_name</a>";
                case '':
                default:
                    $thelist .= '<a href="' . get_category_link(0, $category->category_id, $category->category_nicename) . '" title="' . sprintf(__("View all posts in %s"), $category->cat_name) . '">'.$category->cat_name.'</a>';
            }
            ++$i;
        }
    }
    echo apply_filters('the_category', $thelist);
}

function jpa_get_nested_categories($default = 0) {
 global $jplink_id, $tablecategories, $tablejplink2cat, $mode, $wpdb;

 if ($jplink_id) {
   $checked_categories = $wpdb->get_col("
     SELECT category_id
     FROM  $tablecategories, $tablejplink2cat
     WHERE $tablejplink2cat.category_id = cat_ID AND $tablejplink2cat.jplink_id = '$jplink_id'
     ");
 } else {
   $checked_categories[] = $default;
 }

 $categories = $wpdb->get_results("SELECT * FROM $tablecategories ORDER BY category_parent DESC, cat_name ASC");
 $result = array();
 foreach($categories as $category) {
   $array_category = get_object_vars($category);
   $me = 0 + $category->cat_ID;
   $parent = 0 + $category->category_parent;
	if (isset($result[$me]))   $array_category['children'] = $result[$me];
   $array_category['checked'] = in_array($category->cat_ID, $checked_categories);
   $array_category['cat_name'] = stripslashes($category->cat_name);
   $result[$parent][] = $array_category;
 }

 return $result[0];
}

function jpa_write_nested_categories($categories) {
 foreach($categories as $category) {
   echo '<label for="category-', $category['cat_ID'], '" class="selectit"><input value="', $category['cat_ID'],
     '" type="checkbox" name="post_category[]" id="category-', $category['cat_ID'], '"',
     ($category['checked'] ? ' checked="checked"' : ""), '/> ', $category['cat_name'], "</label>\n";

   if(isset($category['children'])) {
     echo "\n<span class='cat-nest'>\n";
     write_nested_categories($category['children']);
     echo "</span>\n";
   }
 }
}

function jpa_dropdown_categories($default = 0) {
 jpa_write_nested_categories(jpa_get_nested_categories($default));
}

// -------------------------------------------------------------------------------------------

?>
<div class="wrap"> 
<?php

// Test for install - If not installed set action to install.
if ($action != 'uninstall') { // Could add more, just in case some uninstall prob and the user hits refresh, or accidently hits refresh so that it doesnt reinstall.

$result = mysql_list_tables(DB_NAME);

// Just incase some db problem came up between the header and here, hey it
//   was in the install script so i thought i would puit it in.
if (!$result) {
	print "DB Error, could not list tables\n";
	print 'MySQL Error: ' . mysql_error();
	exit;
}

// Just check incase previous install failed
while ($row = mysql_fetch_row($result)) {
	if ($row[0] == $tablejplinks) {
		$gotjplinks = TRUE;
	} elseif ($row[0] == $tablejplink2cat) {
		$gotjplink2cat = TRUE;
	}
}

if ((!$gotjplinks) or (!$gotjplink2cat)) {
	$action = 'install';
}

}



// Do whatever action is required.
switch($action) {

	case 'install': // DO INSTALL



$result = mysql_list_tables(DB_NAME);

// Just incase some db problem came up between the header and here, hey it
//   was in the install script so i thought i would puit it in.
if (!$result) {
	print "DB Error, could not list tables\n";
	print 'MySQL Error: ' . mysql_error();
	exit;
}

// Just check incase previous install failed
while ($row = mysql_fetch_row($result)) {
	if ($row[0] == $tablejplinks) {
		$gotjplinks = TRUE;
	} elseif ($row[0] == $tablejplink2cat) {
		$gotjplink2cat = TRUE;
	}
}

echo '<h2>JP_Links - Installing</h2>';

if (!$gotjplinks) {

	echo "<p>Can't find table '$tablejplinks', gonna create it...</p>\n";

	$sql = "CREATE TABLE `$tablejplinks` (
`jplink_id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
`jplink_name` VARCHAR( 255 ) NOT NULL ,
`jplink_url` VARCHAR( 255 ) NOT NULL ,
`jplink_description` VARCHAR( 255 ) NOT NULL ,
`jplink_date` DATETIME NOT NULL ,
`jplink_visible` ENUM( 'Y', 'N' ) DEFAULT 'Y' NOT NULL ,
PRIMARY KEY ( `jplink_id` )
);";

	$result = mysql_query($sql) or print ("Can't create the table '$tablejplinks' in the database.<br />" . $sql . "<br />" . mysql_error());

	if ($result != false) {
		echo "<p>Table '$tablejplinks' created OK</p>\n";
		$gotjplinks = TRUE;
	}

} else {
	echo "<p>Found table '$tablejplinks', don't need to create it...</p>\n";
}

if (!$gotjplink2cat) {

	echo "<p>Can't find table '$tablejplink2cat', gonna create it...</p>\n";

	$sql = "CREATE TABLE `$tablejplink2cat` (
`rel_id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
`category_id` INT( 11 ) NOT NULL ,
`jplink_id` INT( 11 ) NOT NULL ,
PRIMARY KEY ( `rel_id` )
);";

	$result = mysql_query($sql) or print ("Can't create the table '$tablejplink2cat' in the database.<br />" . $sql . "<br />" . mysql_error());

	if ($result != false) {
		echo "<p>Table '$tablejplink2cat' created OK</p>\n";
		$gotjplink2cat = TRUE;
	}

} else {
	echo "<p>Found table '$tablejplink2cat', don't need to create it...</p>\n";
}

if (($gotjplinks) and ($gotjplink2cat)) {
	echo '<p><strong>Install Complete.</strong></p>';

	echo '<p>Refresh this page, or <a href="?action=view" title="Browse to jp-links Manage Links Page">Return to JP-Links Link Managment</a></p>';
} else {
	echo '<p><strong>Install <em>NOT</em> Complete.</strong></p>';
}

	break;



	case 'uninstallconf': // CONFIRM UNINSTALL



?>
<h2>JP_Links - UnInstalling</h2>

<p>Are you really sure you want to delete jplinks?</p>

<p>Taking this action will remove the jplinks tables. However it will not delete the plugin or admin files.</p>

<p><a href="?action=uninstall">Yes, Delete JP-Links</a> OR <a href="?action=view">No, Return to JP-Links Link managment</a>.</p>
<?php
	break;



	case 'uninstall': // DO UNINSTALL



echo '<h2>JP_Links - UnInstalling</h2>';

if ($user_level == 10) {

	$sql = "DROP TABLE `$tablejplinks`";

	$result = mysql_query($sql) or print ("<br />Can't delete the table '$tablejplinks' in the database.<br />" . $sql . "<br />" . mysql_error());

	if ($result != false) {
		echo "<p>Table '$tablejplinks' deleted OK</p>\n";
	}

	$sql = "DROP TABLE `$tablejplink2cat`";

	$result = mysql_query($sql) or print ("<br />Can't delete the table '$tablejplink2cat' in the database.<br />" . $sql . "<br />" . mysql_error());

	if ($result != false) {
		echo "<p>Table '$tablejplink2cat' deleted OK</p>\n";
	}

	echo '<p><strong>UnInstall Complete.</strong></p>';

	echo '<p><strong>WARNING</strong> - Do not retuen to any jp-links admin page unless you want jp-links to be automatically re-installed.</p>';

} else {
	echo '<p><strong>You are <em>NOT</em> authorized to uninstall jp_links.</strong></p>';
}
	break;



	case 'delete':

	echo '<h2>JP_Links - Delete Item</h2>';

	if (isset($_GET['jplink_id'])) {

		$jplink_id = $_GET['jplink_id'];

		echo 'DELETE ... WHERE jplink_id = '.$jplink_id.'<br />';

		$sql = "DELETE FROM $tablejplinks WHERE `jplink_id` = '$jplink_id'";
		$result = $wpdb->query($sql);

		if ($result) { echo 'Deleted from '.$tablejplinks; } else { echo 'Failed to delete from '.$tablejplinks; } 

		$sql = "DELETE FROM $tablejplink2cat WHERE `jplink_id` = '$jplink_id'";
		$result = $wpdb->query($sql);

		if ($result) { echo 'Deleted from '.$tablejplink2cat; } else { echo 'Failed to delete from '.$tablejplink2cat; }

	} else {
		echo '<p>error, please specity jplink_id to delete</p>';
	}

	echo '<p><a href="?action=view">Manage</a> or <a href="?action=edit">Add a new link</a></p>';

	break;



	case 'doedit': // DO EDIT: EDITS OR ADDS A LINK

// This is very, very messy, but it kind of does the job. slightly shamefull ;) Im kind of working it in a different way from how I usually do things to be more like the wp methods.

$postaccepted = array('jplink_id','jplink_name','jplink_url','jplink_description','jplink_visible','post_category');

$postrequired = array('jplink_name','jplink_url','jplink_description');

echo '<h2>JP_Links - Doing Action</h2><h3>Debug Print Out</h3>';

foreach ($_POST as $key => $val) {
	if(in_array($key,$postaccepted)) {
		$$key = $val;
		echo 'Post value accepted and translated: '.$key.' - '.$$key.'<br />';
	}
}

$errormsg = '';

foreach ($postrequired as $post) {
	if (empty($$post)) {
		$error = TRUE;
		$missing = TRUE;
		$errormsg .= '<li>Value missing for '.ucfirst(substr($post,7)).'</li>';
	}
}

if(count($post_category) < 1) {
	$error = TRUE;
	$errormsg .= '<li>You must set at least one category - categories returned to default / previous setting.</li>';
}

if ($error) {

	echo '<p>Please resolve the following errors and try again.<ul>';

	echo $errormsg;

	echo '</ul></p>';

}

// Give visible a valid setting.
(!$jplink_visible) ? $jplink_visible = FALSE : $jplink_visible = TRUE;


if (!$error) {

	$tablejplinks_values = array('jplink_id','jplink_name','jplink_url','jplink_description','jplink_date','jplink_visible');
	$jplink_date = date('Y-m-d H:i:s',time() + (get_settings('gmt_offset') * 3600)); //YYYY-MM-DD HH-MM-SS
	// No post related errors at this point so give the db stuff a go.
	if ($jplink_id) {

		echo "<br />UPDATE ... WHERE jplink_id = '$jplink_id'<br />";

		$sql = "UPDATE $tablejplinks SET
			jplink_name = '$jplink_name',
			jplink_url = '$jplink_url',
			jplink_description = '$jplink_description',
			jplink_date = '$jplink_date',
			jplink_visible = '$jplink_visible'
			WHERE `jplink_id` = '$jplink_id'";

		$result = $wpdb->query($sql);

		$old_categories = $wpdb->get_col("SELECT `category_id` FROM `$tablejplink2cat` WHERE `jplink_id` = '$jplink_id'");
	
		// Delete any?
		foreach ($old_categories as $old_cat) {
			if (!in_array($old_cat, $post_category)) // If a category was there before but isn't now
				$wpdb->query("DELETE FROM `$tablejplink2cat` WHERE `category_id` = '$old_cat' AND `jplink_id` = '$jplink_id' LIMIT 1");
		}
	
		// Add any?
		foreach ($post_category as $new_cat) {
			if (!in_array($new_cat, $old_categories))
				$wpdb->query("INSERT INTO `$tablejplink2cat` ( `rel_id` , `category_id` , `jplink_id` ) VALUES ( '' , '$new_cat' , '$jplink_id' )");
		}

		echo 'done updating';
		
	} else {

		// ADD
		
		echo '<br />INSERT<br />';

		$sql = "INSERT INTO $tablejplinks ( `jplink_id` , `jplink_name` , `jplink_url` , `jplink_description` , `jplink_date` , `jplink_visible` )
				VALUES ( '' , '$jplink_name' , '$jplink_url' , '$jplink_description' , '$jplink_date' , '$jplink_visible' )";
		$result = $wpdb->query($sql);

		// select last item in jplinks get its id and set to jplink_id
		$sql = "SELECT `jplink_id` FROM $tablejplinks ORDER BY `jplink_id` DESC LIMIT 1";
		$result = $wpdb->get_results($sql);
		$jplink_id = $result[0]->jplink_id;

		$sql = "INSERT INTO `$tablejplink2cat` ( `rel_id` , `category_id` , `jplink_id` ) VALUES ";
		$catcount = 0;
		$cats = count($post_category);
		foreach ($post_category as $cat) {
			$catcount ++;
			$sql .= "( '' , '$cat' , '$jplink_id' )";
			if ($catcount < $cats) {
				$sql .= ', ';
			}
		}
		$result = $wpdb->query($sql);
		
	}

	// Everything worked out so break;
	echo '<p>Action completed successfully!</p>';
	echo '<p><a href="?action=view">Manage</a> or <a href="?action=edit">Add a new link</a></p>';
	break;
}

$doediterror = TRUE;



	case 'edit': // MAKE EDIT SCREEN



include(ABSPATH.'wp-blog-header.php');

?>

<form name="post" action="jp-linksedit.php?action=doedit" method="post" id="post">

<?php

if (isset($_GET['jplink_id'])) {

	$jplink_id = $_GET['jplink_id'];

	$title = 'Edit';

	$sql = "SELECT *
FROM `$tablejplinks`
WHERE $tablejplinks.jplink_id = $jplink_id;";

	$response = $wpdb->get_results($sql);

	if ($response) {
		foreach($response[0] as $key => $val) {
			$$key = $val;
		}
	}

	// Get the data from the database and extract it to variables.

} else {

	$title='Add';

}

?>

<h2>JP_Links <?php echo $title ?> Link</h2>

<p>
<label for="jplink_id">ID</label><input type="text" id="jplink_id" name="jplink_id" value="<?php echo $jplink_id ?>" />
</p>

<p>
<label for="jplink_name">Name</label><input type="text" id="jplink_name" name="jplink_name" value="<?php echo $jplink_name ?>" />
</p>

<p>
<label for="jplink_url">URL</label><input type="text" id="jplink_url" name="jplink_url" value="<?php echo $jplink_url ?>" />
</p>

<p>
<label for="jplink_description">Description</label><input type="text" id="jplink_description" name="jplink_description" value="<?php echo $jplink_description ?>" />
</p>

<p>
<input type="checkbox" id="jplink_visible" name="jplink_visible" <?php if (($jplink_visible == 'Y') or (!$jplink_visible)) echo 'checked'; ?> /><label for="jplink_visible">Visible</label>
</p>

    <fieldset id="categorydiv2">
      <legend><a href="http://wordpress.org/docs/reference/post/#category" title="<?php _e('Help on categories') ?>"><?php _e('Categories') ?></a></legend> 
	  <div><?php jpa_dropdown_categories(get_settings('default_category')); ?></div>
    </fieldset>

<p class="submit" style="clear:both;">
<input type="submit" name="submit" value="<?php _e('Save') ?>" style="font-weight: bold;" />
</p>

</form>

<?php

// Post info overwrites database info, how, process database first then post.
	break;



	case 'view': // BEGIN VIEW LINKS



?>

<h2>JP_Links - Manage Links</h2>

<table width="100%" cellpadding="3" cellspacing="3">
  <tr> 
    <th scope="col"><?php _e('ID') ?></th>
    <th scope="col"><?php _e('When') ?></th>
    <th scope="col"><?php _e('Name') ?></th>
    <th scope="col"><?php _e('Description') ?></th>
    <th scope="col"><?php _e('Categories') ?></th>
    <th scope="col"><?php _e('Visible') ?></th>
    <th scope="col"><?php _e('Edit') ?></th>
    <th scope="col"><?php _e('Delete') ?></th>
  </tr>

<?php

include(ABSPATH.'wp-blog-header.php');

	$response = $wpdb->get_results("
SELECT $tablejplinks.*
FROM  $tablejplinks
");

if ($response) {

$bgcolor = '';

foreach ($response as $link) {

	$bgcolor = ('#eee' == $bgcolor) ? 'none' : '#eee';

	?>

  <tr style="background-color: <?php echo $bgcolor; ?>;">
    <th scope="row"><?php echo $link->jplink_id ?></th>
    <td><?php echo date('Y-m-d \<\b\r \/\> g:i:s a',strtotime($link->jplink_date)); ?></td>
    <td><a href="<?php echo $link->jplink_url ?>" title="<?php echo $link->jplink_description ?>">
      <?php echo $link->jplink_name ?>
      </a>
    </td>
    <td><?php echo $link->jplink_description ?></td>
    <td><?php jpa_the_category(','); ?></td>
    <td><?php echo $link->jplink_visible ?></td>
    <td><?php if (($user_level > $authordata->user_level) or ($user_login == $authordata->user_login)) { echo '<a href="jp-linksedit.php?action=edit&amp;jplink_id='.$link->jplink_id.'" class="edit">' . __('Edit') . "</a>"; } ?></td> 
    <td><?php if (($user_level > $authordata->user_level) or ($user_login == $authordata->user_login)) { echo '<a href="jp-linksedit.php?action=delete&amp;jplink_id='.$link->jplink_id.'" class="delete" onclick="return confirm(\'' . sprintf(__("You are about to delete this post \'%s\'\\n  \'OK\' to delete, \'Cancel\' to stop."), the_title('','',0)) . '\')">' . __('Delete') . '</a>'; } ?></td>
  </tr>

<?php

}

} else {

?>

  <tr style="background-color: <?php echo $bgcolor; ?>;">
    <td colspan="7"><?php _e('No posts found.') ?></td><!-- Well it will be language compliant, even if its kinda stuffed at least anyone will know its empty. -->
  </tr>

<?php

} // end if ($response)

?>

</table>

<p>
<a href="?action=edit" title="Add new link">Add new link</a> - <a href="?action=uninstallconf" title="Uninstall jp-links">UnInstall JP-Links</a>
</p>

<?php

	break;  // END VIEW LINKS



	default: // SELECTED ACTION DOES NOT EXIST



	echo '<h2>JP_Links - Error</h2>
<p><strong>Invalid action.</strong></p>';



} // END OF SELECT $ACTION
?>
</div>
<?php include('admin-footer.php'); ?>
